using ImageProcessingGraph.Editor;
using UnityEditor;
using UnityEngine;
using UnityEngine.UIElements;

using System.Collections.Generic;
using ImageProcessingGraph.Editor.Nodes.Types.Image.Variable_Node;
using UnityEditor;
using UnityEditor.UIElements;
using UnityEngine;
using UnityEngine.UIElements;

public class BatchingWindow : EditorWindow
{
    [SerializeField]
    private VisualTreeAsset m_VisualTreeAsset = default;

    [SerializeField]
    private ImageProcessingGraphAsset m_ImageProcessingGraphAsset;

    private static Dictionary<ImageProcessingGraphAsset, BatchingWindow> s_OpenWindows = new();
    private List<Foldout> variableNodeFoldouts = new();

    public static void OpenBatchingWindow(ImageProcessingGraphAsset asset)
    {
        if (s_OpenWindows.TryGetValue(asset, out BatchingWindow existingWindow))
        {
            existingWindow.Focus();
            return;
        }

        BatchingWindow window = CreateInstance<BatchingWindow>();
        window.titleContent = new GUIContent($"{asset.name} Batcher");
        window.m_ImageProcessingGraphAsset = asset;
        window.Show();

        s_OpenWindows[asset] = window;
    }

    private void OnDestroy()
    {
        if (m_ImageProcessingGraphAsset != null)
            s_OpenWindows.Remove(m_ImageProcessingGraphAsset);
    }

    public void CreateGUI()
    {
        VisualElement root = rootVisualElement;
        var VariableNodes = m_ImageProcessingGraphAsset.GetAllVariableNodesWithTypes();

        foreach (var VARIABLE in VariableNodes)
        {
            VariableNodeBase node = VARIABLE.node as VariableNodeBase;

            PropertyField pField = new PropertyField();
            pField.AddToClassList("unity-property-field__inspector-property");
            root.Add(pField);
            
            ListView listView = new ListView();
            listView.AddToClassList("unity-list-view--with-footer");
            listView.AddToClassList("unity-list-view--with-header");
            pField.Add(listView);

        }
    }
}
